

# GetRelationalDatabaseMetricData
<a name="API_GetRelationalDatabaseMetricData"></a>

Returns the data points of the specified metric for a database in Amazon Lightsail.

Metrics report the utilization of your resources, and the error counts generated by them. Monitor and collect metric data regularly to maintain the reliability, availability, and performance of your resources.

## Request Syntax
<a name="API_GetRelationalDatabaseMetricData_RequestSyntax"></a>

```
{
   "endTime": number,
   "metricName": "string",
   "period": number,
   "relationalDatabaseName": "string",
   "startTime": number,
   "statistics": [ "string" ],
   "unit": "string"
}
```

## Request Parameters
<a name="API_GetRelationalDatabaseMetricData_RequestParameters"></a>

For information about the parameters that are common to all actions, see [Common Parameters](CommonParameters.md).

The request accepts the following data in JSON format.

 ** [endTime](#API_GetRelationalDatabaseMetricData_RequestSyntax) **   <a name="Lightsail-GetRelationalDatabaseMetricData-request-endTime"></a>
The end of the time interval from which to get metric data.  
Constraints:  
+ Specified in Coordinated Universal Time (UTC).
+ Specified in the Unix time format.

  For example, if you wish to use an end time of October 1, 2018, at 8 PM UTC, then you input `1538424000` as the end time.
Type: Timestamp  
Required: Yes

 ** [metricName](#API_GetRelationalDatabaseMetricData_RequestSyntax) **   <a name="Lightsail-GetRelationalDatabaseMetricData-request-metricName"></a>
The metric for which you want to return information.  
Valid relational database metric names are listed below, along with the most useful `statistics` to include in your request, and the published `unit` value. All relational database metric data is available in 1-minute (60 seconds) granularity.  
+  ** `CPUUtilization` ** - The percentage of CPU utilization currently in use on the database.

   `Statistics`: The most useful statistics are `Maximum` and `Average`.

   `Unit`: The published unit is `Percent`.
+  ** `DatabaseConnections` ** - The number of database connections in use.

   `Statistics`: The most useful statistics are `Maximum` and `Sum`.

   `Unit`: The published unit is `Count`.
+  ** `DiskQueueDepth` ** - The number of outstanding IOs (read/write requests) that are waiting to access the disk.

   `Statistics`: The most useful statistic is `Sum`.

   `Unit`: The published unit is `Count`.
+  ** `FreeStorageSpace` ** - The amount of available storage space.

   `Statistics`: The most useful statistic is `Sum`.

   `Unit`: The published unit is `Bytes`.
+  ** `NetworkReceiveThroughput` ** - The incoming (Receive) network traffic on the database, including both customer database traffic and AWS traffic used for monitoring and replication.

   `Statistics`: The most useful statistic is `Average`.

   `Unit`: The published unit is `Bytes/Second`.
+  ** `NetworkTransmitThroughput` ** - The outgoing (Transmit) network traffic on the database, including both customer database traffic and AWS traffic used for monitoring and replication.

   `Statistics`: The most useful statistic is `Average`.

   `Unit`: The published unit is `Bytes/Second`.
Type: String  
Valid Values: `CPUUtilization | DatabaseConnections | DiskQueueDepth | FreeStorageSpace | NetworkReceiveThroughput | NetworkTransmitThroughput`   
Required: Yes

 ** [period](#API_GetRelationalDatabaseMetricData_RequestSyntax) **   <a name="Lightsail-GetRelationalDatabaseMetricData-request-period"></a>
The granularity, in seconds, of the returned data points.  
All relational database metric data is available in 1-minute (60 seconds) granularity.  
Type: Integer  
Valid Range: Minimum value of 60. Maximum value of 86400.  
Required: Yes

 ** [relationalDatabaseName](#API_GetRelationalDatabaseMetricData_RequestSyntax) **   <a name="Lightsail-GetRelationalDatabaseMetricData-request-relationalDatabaseName"></a>
The name of your database from which to get metric data.  
Type: String  
Pattern: `\w[\w\-]*\w`   
Required: Yes

 ** [startTime](#API_GetRelationalDatabaseMetricData_RequestSyntax) **   <a name="Lightsail-GetRelationalDatabaseMetricData-request-startTime"></a>
The start of the time interval from which to get metric data.  
Constraints:  
+ Specified in Coordinated Universal Time (UTC).
+ Specified in the Unix time format.

  For example, if you wish to use a start time of October 1, 2018, at 8 PM UTC, then you input `1538424000` as the start time.
Type: Timestamp  
Required: Yes

 ** [statistics](#API_GetRelationalDatabaseMetricData_RequestSyntax) **   <a name="Lightsail-GetRelationalDatabaseMetricData-request-statistics"></a>
The statistic for the metric.  
The following statistics are available:  
+  `Minimum` - The lowest value observed during the specified period. Use this value to determine low volumes of activity for your application.
+  `Maximum` - The highest value observed during the specified period. Use this value to determine high volumes of activity for your application.
+  `Sum` - All values submitted for the matching metric added together. You can use this statistic to determine the total volume of a metric.
+  `Average` - The value of Sum / SampleCount during the specified period. By comparing this statistic with the Minimum and Maximum values, you can determine the full scope of a metric and how close the average use is to the Minimum and Maximum values. This comparison helps you to know when to increase or decrease your resources.
+  `SampleCount` - The count, or number, of data points used for the statistical calculation.
Type: Array of strings  
Valid Values: `Minimum | Maximum | Sum | Average | SampleCount`   
Required: Yes

 ** [unit](#API_GetRelationalDatabaseMetricData_RequestSyntax) **   <a name="Lightsail-GetRelationalDatabaseMetricData-request-unit"></a>
The unit for the metric data request. Valid units depend on the metric data being requested. For the valid units with each available metric, see the `metricName` parameter.  
Type: String  
Valid Values: `Seconds | Microseconds | Milliseconds | Bytes | Kilobytes | Megabytes | Gigabytes | Terabytes | Bits | Kilobits | Megabits | Gigabits | Terabits | Percent | Count | Bytes/Second | Kilobytes/Second | Megabytes/Second | Gigabytes/Second | Terabytes/Second | Bits/Second | Kilobits/Second | Megabits/Second | Gigabits/Second | Terabits/Second | Count/Second | None`   
Required: Yes

## Response Syntax
<a name="API_GetRelationalDatabaseMetricData_ResponseSyntax"></a>

```
{
   "metricData": [ 
      { 
         "average": number,
         "maximum": number,
         "minimum": number,
         "sampleCount": number,
         "sum": number,
         "timestamp": number,
         "unit": "string"
      }
   ],
   "metricName": "string"
}
```

## Response Elements
<a name="API_GetRelationalDatabaseMetricData_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [metricData](#API_GetRelationalDatabaseMetricData_ResponseSyntax) **   <a name="Lightsail-GetRelationalDatabaseMetricData-response-metricData"></a>
An array of objects that describe the metric data returned.  
Type: Array of [MetricDatapoint](API_MetricDatapoint.md) objects

 ** [metricName](#API_GetRelationalDatabaseMetricData_ResponseSyntax) **   <a name="Lightsail-GetRelationalDatabaseMetricData-response-metricName"></a>
The name of the metric returned.  
Type: String  
Valid Values: `CPUUtilization | DatabaseConnections | DiskQueueDepth | FreeStorageSpace | NetworkReceiveThroughput | NetworkTransmitThroughput` 

## Errors
<a name="API_GetRelationalDatabaseMetricData_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
Lightsail throws this exception when the user cannot be authenticated or uses invalid credentials to access a resource.  
HTTP Status Code: 400

 ** AccountSetupInProgressException **   
Lightsail throws this exception when an account is still in the setup in progress state.  
HTTP Status Code: 400

 ** InvalidInputException **   
Lightsail throws this exception when user input does not conform to the validation rules of an input field.  
Domain and distribution APIs are only available in the N. Virginia (`us-east-1`) AWS Region. Please set your AWS Region configuration to `us-east-1` to create, view, or edit these resources.
HTTP Status Code: 400

 ** NotFoundException **   
Lightsail throws this exception when it cannot find a resource.  
HTTP Status Code: 400

 ** OperationFailureException **   
Lightsail throws this exception when an operation fails to execute.  
HTTP Status Code: 400

 ** RegionSetupInProgressException **   
Lightsail throws this exception when an operation is performed on resources in an opt-in Region that is currently being set up.    
 ** docs **   
 [Regions and Availability Zones for Lightsail](https://docs.aws.amazon.com/lightsail/latest/userguide/understanding-regions-and-availability-zones-in-amazon-lightsail.html)   
 ** tip **   
Opt-in Regions typically take a few minutes to finish setting up before you can work with them. Wait a few minutes and try again.
HTTP Status Code: 400

 ** ServiceException **   
A general service exception.  
HTTP Status Code: 500

 ** UnauthenticatedException **   
Lightsail throws this exception when the user has not been authenticated.  
HTTP Status Code: 400

## See Also
<a name="API_GetRelationalDatabaseMetricData_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/lightsail-2016-11-28/GetRelationalDatabaseMetricData) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/lightsail-2016-11-28/GetRelationalDatabaseMetricData) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/lightsail-2016-11-28/GetRelationalDatabaseMetricData) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/lightsail-2016-11-28/GetRelationalDatabaseMetricData) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/lightsail-2016-11-28/GetRelationalDatabaseMetricData) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/lightsail-2016-11-28/GetRelationalDatabaseMetricData) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/lightsail-2016-11-28/GetRelationalDatabaseMetricData) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/lightsail-2016-11-28/GetRelationalDatabaseMetricData) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/lightsail-2016-11-28/GetRelationalDatabaseMetricData) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/lightsail-2016-11-28/GetRelationalDatabaseMetricData) 